OUTDIR=..\..\execs
INTDIR=..\..\execs
ALL : "$(OUTDIR)\SPHYSICS_2D.exe"
"$(OUTDIR)" :
    if not exist "$(OUTDIR)/$(NULL)" mkdir "$(OUTDIR)"
F90=df.exe
F90_PROJ=/compile_only /nologo /warn:nofileopt /module:"..\..\execs/" /object:"..\..\execs/"
F90_OBJS=..\..\execs/
.SUFFIXES: .fpp
.f{$(F90_OBJS)}.obj:
   $(F90) $(F90_PROJ) $<
LINK32=link.exe
LINK32_FLAGS=kernel32.lib /nologo /subsystem:console /incremental:no /pdb:"$(OUTDIR)\SPHYSICS_2D.pdb" /machine:I386 /out:"$(OUTDIR)\SPHYSICS_2D.exe"
LINK32_OBJS= \
     "$(INTDIR)\energy_2D.obj" \
     "$(INTDIR)\recover_list_2D.obj" \
     "$(INTDIR)\ini_divide_2D.obj" \
     "$(INTDIR)\keep_list_2D.obj" \
     "$(INTDIR)\shepard_2D.obj" \
     "$(INTDIR)\SPHYSICS_2D.obj" \
     "$(INTDIR)\getdata_2D.obj" \
     "$(INTDIR)\check_limits_2D.obj" \
     "$(INTDIR)\poute_2D.obj" \
     "$(INTDIR)\divide_2D.obj" \
     "$(INTDIR)\variable_time_step_2D.obj" \
     "$(INTDIR)\ac_2D.obj" \
     "$(INTDIR)\movingObjects_2D.obj" \
     "$(INTDIR)\movingPaddle_2D.obj" \
     "$(INTDIR)\movingWedge_2D.obj" \
     "$(INTDIR)\updateNormals_2D.obj" \
     "$(INTDIR)\self_BC_Monaghan_2D.obj" \
     "$(INTDIR)\celij_BC_Monaghan_2D.obj" \
     "$(INTDIR)\MonaghanBC_2D.obj" \
     "$(INTDIR)\viscosity_laminar+SPS_2D.obj" \
     "$(INTDIR)\correct_SPS_2D.obj" \
     "$(INTDIR)\kernel_quadratic_2D.obj" \
     "$(INTDIR)\step_predictor_corrector_2D.obj" 
"$(OUTDIR)\SPHYSICS_2D.exe" : "$(OUTDIR)" $(DEF_FILE) $(LINK32_OBJS)
   $(LINK32) @<<
 $(LINK32_FLAGS) $(LINK32_OBJS)
<<
!IF "$(NO_EXTERNAL_DEPS)" != "1"
!IF EXISTS("SPHYSICS_2D.dep")
!INCLUDE "SPHYSICS_2D.dep"
!ELSE
!MESSAGE Warning: cannot find "SPHYSICS_2D.dep"
!ENDIF
!ENDIF
SOURCE=.\SPHYSICS_2D.f
"$(INTDIR)\SPHYSICS_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\energy_2D.f
"$(INTDIR)\energy_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\recover_list_2D.f
"$(INTDIR)\recover_list_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\ini_divide_2D.f
"$(INTDIR)\ini_divide_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\keep_list_2D.f
"$(INTDIR)\keep_list_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\shepard_2D.f
"$(INTDIR)\shepard_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\getdata_2D.f
"$(INTDIR)\getdata_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\check_limits_2D.f
"$(INTDIR)\check_limits_2D.obj" : $(SOURCE) "$(INTDIR)"
"$(INTDIR)\variable_time_step_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\divide_2D.f
"$(INTDIR)\divide_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\poute_2D.f
"$(INTDIR)\poute 2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\updateNormals_2D.f
"$(INTDIR)\updateNormals_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\ac_2D.f
"$(INTDIR)\ac_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\movingObjects_2D.f
"$(INTDIR)\movingObjects_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\movingPaddle_2D.f
"$(INTDIR)\movingPaddle_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\movingWedge_2D.f
"$(INTDIR)\movingWedge_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\self_BC_Monaghan_2D.f
"$(INTDIR)\self_BC_Monaghan_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\celij_BC_Monaghan_2D.f
"$(INTDIR)\celij_BC_Monaghan_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\viscosity_laminar+SPS_2D.f
"$(INTDIR)\viscosity_laminar+SPS_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\correct_SPS_2D.f
"$(INTDIR)\correct_SPS_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\kernel_quadratic_2D.f
"$(INTDIR)\kernel_quadratic_2D.obj" : $(SOURCE) "$(INTDIR)"
SOURCE=.\step_predictor_corrector_2D.f
"$(INTDIR)\step_predictor_corrector_2D.obj" : $(SOURCE) "$(INTDIR)"
