c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.
       
       program sph
       
C
c			Axis
c			^
c			|      / Y
c                 Z  |     /
c			|    /
c			|   /
c			|  /
c			| /
c			|/
c			--------------> X
c
       
       include 'common.2D'
       
       character supp*4,name*40,detsupp*4
              
       REAL time_begin, time_end
       CALL CPU_TIME (time_begin)
       
       print*
       write(*,*) '<SPHYSICS>  Copyright (C) <2007>'
       write(*,*) 
     & '<Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, '
       write(*,*) 
     & 'Dr Benedict Rogers, Alejandro Crespo, '
       write(*,*) 
     & 'Muthukumar Narayanaswamy, Dr Shan Zou, and Dr Andrea Panizzo >'
       write(*,*) 'This program comes with ABSOLUTELY NO WARRANTY;    '
       write(*,*) 'This is free software, and you are welcome to      '
       write(*,*) 'redistribute it under conditions stated in         '
       write(*,*) 'the GPL License;                                   '

       print*
       print*,' ---     SPHYSICS_2D.F       ---'
       print*,' ---   Distributed under     ---'
       print*,' ---    the GPL License      ---'
       print*
       
c
c  ...  file specifications
c
       
       open(22,file='SCAL')
       
       open(52,file='DETSCAL')   !Detailed SCAL information
       
       open(50,file='ENERGY')
       
       open(19,file='DT')
       
       write(19,*) 'time dt1 dt2 dt_new'
       
       pi=4.*atan(1.)
       g=9.81
       ivort_calc = 0
       
c
c  ...  initialization
c      
       call getdata
       call energy(g)
       
       call ini_divide(1)
       call divide(1,nbf,1)
       call keep_list
       
c
c  .............................. MAIN LOOP ...................................
c
       
       tdetail=0
       nimad=0
       itime = 0
       ngrab = 0
       grab_P = 0.0
       grab_E = 0.0
       
       grx=0.0
       gry=0.0
       grz=-g
              
       do while (time.lt.tmax)
          visc_dt=0.
       
         if(grab_P.gt.out.and.time.ge.trec_ini)then
            ivort_calc = 1
         else
            ivort_calc = 0
         endif
           	         
         !-- Call Main Subroutines --  
         call step
                  
         !-- File Output Routines --
         if(grab_P.gt.out.and.time.ge.trec_ini) then 
       
           ngrab=ngrab+1
           write(supp,'(i4.4)') ngrab
           !print*,'supp =',supp
           name='PART_'//supp
           write(*,*) name
           open(23,file=name)
       
           call poute(22)
           
           close(23)
       
           grab_P=0.
       
         endif
       
         
         if(i_densityFilter.eq.1.and.
     &        itime/30*30.eq.itime)then 
                 !write(*,*)' call Shepard at time= ', time
           call shepard(1)
         endif
         
         if(grab_E.gt.out.or.time.eq.trec_ini) then
           call energy(g)
           grab_E=0.
         endif  
                                   
c        -- Detailed recording --    
          tdetail=tdetail+dt
       
          if(time.ge.t_sta_det.and.
     +       time.le.t_end_det.and.
     +       tdetail.ge.dtrec_det)then
            tdetail=0
	      ngrabdet=ngrabdet+1
	      write(detsupp,'(i4.4)') ngrabdet

            name='DETPART_'//detsupp
            write(*,*) name
            open(53,file=name)
            call poute(52)
            close(53)
          endif
              
         itime = itime+1
         time = time + dt 
       
         grab_P=grab_P+dt
         grab_E=grab_E+dt
         
       enddo
       
       open(32,file='ESCAL')
       open(33,file='EPART')
                                                 
       call poute(32)   !  Final record      
                
       close(32) 
       close(33)                                      
       
       
C	Closing files
       close(22) 
       close(52) 
       close(53) 
       close(50)
       close(19)
       
       write(*,*) 'End '
       
       
       CALL CPU_TIME ( time_end )
       write(*,*)'time_begin',time_begin,'seconds'
       write(*,*)'time_end',time_end,'seconds'
       write(*,*)'Time of operation was',time_end - time_begin,'seconds'
       
       
       end       !end main program
       
