c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine ac
c
      include 'common.2D'

c
c  ...  store useful arrays
c

      do i=nstart,np
         pr(i) = p(i)/(rhop(i)*rhop(i))
c
c        determine the speed of sound: cs**2=d P/d rho
c
         !cs2    = gamma * B * (rhop(i)/rho0)**gamma / rhop(i)
         !cs(i) = sqrt(cs2)
         
         cs(i) = cs0*((rhop(i)/rho0)**3)
         pVol(i) = pm(i)/rhop(i)

c        -- Zeroing Variables --         
         ax(i) = 0.
         az(i) = 0.
         ar(i) = 0.

         ux(i) = 0.
         wx(i) = 0.
         
         aTE(i)=0.
		

         sum_wab(i) = 0.
         rhop_sum(i) = 0.
         sum_dWdx(i) = 1.
         sum_dWdz(i) = 1.

         dudx_CSPH(i) = 0.0
         dudz_CSPH(i) = 0.0
         dwdx_CSPH(i) = 0.0
         dwdz_CSPH(i) = 0.0

         tau_xx_uno_rho2(i) = 0.0
         tau_xz_uno_rho2(i) = 0.0
         tau_zz_uno_rho2(i) = 0.0


c       ---  Clear vorticity arrays ---

          if(ivort_calc.eq.1)then
           if(vorty(i).gt.vortmax)vortmax=vorty(i)
           if(vorty(i).lt.vortmin)vortmin=vorty(i)
           vorty(i) = 0.

           if(rhop(i).gt.densitymax)densitymax=rhop(i)
           if(rhop(i).lt.densitymin)densitymin=rhop(i)
           
           curl3y_a(i)= 0.
           curl3y_b(i)= 0.
         end if

      enddo

           
       ly2 = 0   !Default Y-Periodic value
       kind=1 !kind1+kind2-1 
       do kind_p1=1,2
       ini_kind_p2=mod(kind_p1,2)+1
       
       
       do lz=1,ncz
       do lx=1,ncx
         j1 = lx + (lz-1)*ncx
         
         if(nc(j1,kind_p1).gt.0) then
c                            ! if the cell is not empty, then
c                            ! loop over it and over neighboring
c                            ! cells


c          -- Cells in the same XY sheet -
           lx2 = lx+1
           if(lx2.le.ncx)then
             call celij(j1,j1+1,kind,kind_p1,ini_kind_p2)     !East
           endif      
      
           lz2=lz+1
           if(lz2.le.ncz)then
       
             !- Same row -
             call celij(j1,j1+ncx,kind,kind_p1,ini_kind_p2)   !North
       
             lx2=lx-1
             if(lx2.ge.1) call celij(j1,j1+ncx-1,kind,
     &                                 kind_p1,ini_kind_p2)   !North-West
       
             lx2=lx+1
             if(lx2.le.ncx) call celij(j1,j1+ncx+1,kind,
     &                                 kind_p1,ini_kind_p2)   !North-East                 
       
           endif    !End of:   if(lz2.le.ncz)then
         endif    !End of:  if(nc(j1,kind_p1).gt.0) then
       
       enddo
       enddo
       
       do j1=1,nct
           if(nc(j1,kind_p1).gt.0)
     +		call self(j1,kind,kind_p1,ini_kind_p2)
       enddo
             
       enddo   !End of:  do kind_p1=1,2
             
       
       do i=nstart,np
         
         udot(i) = ax(i)
         wdot(i) = az(i)
         rdot(i) = ar(i)
       
         if(sum_wab(i).lt.0.1) then
            one_over_sum_wab=1.
         else
           one_over_sum_wab=1./sum_wab(i)
         endif
       
         xcor(i) = eps*ux(i)   !*one_over_sum_wab	! NORMALIZING KERNELS
         zcor(i) = eps*wx(i)   !*one_over_sum_wab
       
         TEdot(i)=aTE(i)
       
       enddo
              
       return
       end

