c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.
       
       subroutine divide(n_start,n_end,kind_p)
       include 'common.2D'
       
c     ist and ien are the starting and ending values of the positions in the linear
c     array ip (corresponding to a list of particle numbers) for the particles 
c     in cell ii
c
       do k=n_start,n_end
         if (iflag(k).ne.0) then
         	
           dx = xp(k) - xmin
           dz = zp(k) - zmin
       
           icell = int( dx * one_over_2h ) + 1
           kcell = int( dz * one_over_2h ) + 1
       
           ! ii is the linear cell position in the matrix of 2h cells
           ii    = icell + (kcell - 1)*ncx 
                                                        
           ! nc is the number of particles in cell ii
           nc(ii,kind_p) = nc(ii,kind_p)+1	
                                      
       
           ien(ii,kind_p) = ien(ii,kind_p)+1
           do m=ien(nct,kind_p),ien(ii,kind_p),-1
             if(m.gt.0)ip(m+1,kind_p) = ip(m,kind_p)
           enddo
       
           do m=ii+1,nct
             ist(m,kind_p)=ist(m,kind_p)+1
             ien(m,kind_p)=ien(m,kind_p)+1
           enddo
           
           ip(ien(ii,kind_p),kind_p) = k
           
         endif
       enddo 
       
       return
       end