c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

       subroutine shepard(kind)

      include 'common.2D'

       if(i_kernel.eq.1)then            ! gaussian kernel
         adh=a2(kind)
       else if(i_kernel.eq.2)then		  ! quadratic kernel
         adh=b1(kind)
       else if(i_kernel.eq.3)then		  ! cubic kernel
         adh=a2(kind)
       else if(i_kernel.eq.5)then		  ! Wendland kernel
         adh=Awen(kind)
       endif

       do i=nbp1,np
         sum_wab(i) = sum_wab(i) + adh*pm(i)/rhop(i)  !self contribution
         rhop_sum(i) = rhop_sum(i) + adh*pm(i)  !self contribution
         rhop(i) = rhop_sum(i)/sum_wab(i)
         p(i) = B * ( (rhop(i)/rho0)**i_gamma - 1.)
       enddo


       return
       end

