c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine viscosity(dot,drx,drz,dux,duz,kind,rr2,
     +	             cbar,robar,one_over_rhobar,i,j,j1,j2,term2)

      include 'common.2D'  	


      tau_xx_c = tau_xx_uno_rho2(i)+tau_xx_uno_rho2(j)
      tau_xz_c = tau_xz_uno_rho2(i)+tau_xz_uno_rho2(j)
      tau_zz_c = tau_zz_uno_rho2(i)+tau_zz_uno_rho2(j)

	
               ax(i) = ax(i) + pm(j)*
     &             (tau_xx_c*frx  
     &            + tau_xz_c*frz)
               az(i) = az(i) + pm(j)*
     &             (tau_xz_c*frx  
     &            + tau_zz_c*frz)

          if (j1.ne.j2) then			! only for celij
               ax(j) = ax(j) - pm(i)*
     &             (tau_xx_c*frx  
     &            + tau_xz_c*frz)
               az(j) = az(j) - pm(i)*
     &             (tau_xz_c*frx  
     &            + tau_zz_c*frz)
          endif
c         -----------------

c         --- Viscous Diffusion terms (Morris et al 1997) ---

          temp = 2.*viscos_val*one_over_rhobar*
     &    ((drx*frx+drz*frz)/(rr2 + eta2))

          ax(i) = ax(i) + pm(j)*temp*dux
          az(i) = az(i) + pm(j)*temp*duz

          if (j1.ne.j2) then			! only for celij
	      ax(j) = ax(j) - pm(i)*temp*dux
             az(j) = az(j) - pm(i)*temp*duz
          endif

	   term2=- 0.5 * temp *( dux*dux+duz*duz)-
     +    0.5*((dux*(tau_xx_c*frx+ tau_xz_c*frz)+
     +          duz*(tau_xz_c*frx+ tau_zz_c*frz)))



	return
	end
